"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptionParser = void 0;
var generic_parser_1 = require("./generic_parser");
var SubscriptionParser = /** @class */ (function (_super) {
    __extends(SubscriptionParser, _super);
    function SubscriptionParser(xml) {
        return _super.call(this, xml) || this;
    }
    SubscriptionParser.prototype.subscribe = function (request) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var response = {};
            var found;
            var currentXPath;
            _this.parser.on('tagOpen', function (pTag) {
                if (currentXPath) {
                    currentXPath = currentXPath + '.' + pTag.name;
                }
                else {
                    currentXPath = pTag.name;
                }
                for (var _i = 0, request_1 = request; _i < request_1.length; _i++) {
                    var sub = request_1[_i];
                    if (currentXPath === sub.tag) {
                        found = sub;
                        return;
                    }
                }
            });
            _this.parser.on('text', function (pText) {
                if (found) {
                    var key = found.name;
                    var value = found.converter ? found.converter.convert(pText.contents.trim()) : pText.contents.trim();
                    // if element already in the response convert to array
                    if (key in response) {
                        if (!(response[key] instanceof Array)) {
                            response[key] = [response[key]];
                        }
                        response[key].push(value);
                    }
                    else {
                        response[key] = value;
                    }
                }
            });
            _this.parser.on('tagClose', function (pTag) {
                found = null;
                currentXPath = currentXPath.substr(0, currentXPath.lastIndexOf('.'));
            });
            _this.parser.on('finish', function () {
                resolve(response);
            });
            _this.parser.on('error', function (err) {
                reject(err);
            });
            _this.parser.parse(_this.xml);
        });
    };
    return SubscriptionParser;
}(generic_parser_1.GenericParser));
exports.SubscriptionParser = SubscriptionParser;
